import{s as $e,o as ke,n as qe}from"../chunks/scheduler.6062bdaf.js";import{S as Pe,i as De,g as d,s as r,r as h,A as Ce,h as p,f as o,c as a,j as P,u as f,x as C,k as D,y as c,a as n,v as g,d as _,t as v,w as y}from"../chunks/index.4bca734e.js";import{D as B}from"../chunks/Docstring.ed07512f.js";import{C as Fe}from"../chunks/CodeBlock.fa01571c.js";import{E as Xe}from"../chunks/ExampleCodeBlock.823fb173.js";import{H as _e}from"../chunks/Heading.723dceba.js";function Me(J){let i,F="Example usage:",b,m,l;return m=new Fe({props:{code:"ZnJvbSUyMG9wdGltdW0uZXhwb3J0ZXJzLm9ubnglMjBpbXBvcnQlMjBtYWluX2V4cG9ydCUwQSUwQW1haW5fZXhwb3J0KCUyMmdwdDIlMjIlMkMlMjBvdXRwdXQlM0QlMjJncHQyX29ubnglMkYlMjIp",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.exporters.onnx <span class="hljs-keyword">import</span> main_export

<span class="hljs-meta">&gt;&gt;&gt; </span>main_export(<span class="hljs-string">&quot;gpt2&quot;</span>, output=<span class="hljs-string">&quot;gpt2_onnx/&quot;</span>)`,wrap:!1}}),{c(){i=d("p"),i.textContent=F,b=r(),h(m.$$.fragment)},l(s){i=p(s,"P",{"data-svelte-h":!0}),C(i)!=="svelte-1ni337v"&&(i.textContent=F),b=a(s),f(m.$$.fragment,s)},m(s,u){n(s,i,u),n(s,b,u),g(m,s,u),l=!0},p:qe,i(s){l||(_(m.$$.fragment,s),l=!0)},o(s){v(m.$$.fragment,s),l=!1},d(s){s&&(o(i),o(b)),y(m,s)}}}function Ee(J){let i,F,b,m,l,s,u,ve='You can export models to ONNX from two frameworks in 🤗 Optimum: PyTorch and TensorFlow. There is an export function for each of these frameworks, <a href="/docs/optimum/main/en/exporters/onnx/package_reference/export#optimum.exporters.onnx.convert.export_pytorch">export_pytorch()</a> and <a href="/docs/optimum/main/en/exporters/onnx/package_reference/export#optimum.exporters.onnx.convert.export_tensorflow">export_tensorflow()</a>, but the recommended way of using those is via the main export function <code>~optimum.exporters.main_export</code>, which will take care of using the proper exporting function according to the available framework, check that the exported model is valid, and provide extended options to run optimizations on the exported model.',G,X,Z,x,M,me,j,ye="Full-suite ONNX export.",le,q,Y,w,E,ue,z,be="Exports a Pytorch or TensorFlow model to an ONNX Intermediate Representation.",K,N,I,xe,V,we="Exports a PyTorch model to an ONNX Intermediate Representation.",ee,O,A,he,H,Ne="Exports a TensorFlow model to an ONNX Intermediate Representation.",oe,R,te,T,U,fe,S,Oe="Checks that the dummy inputs from the ONNX config is a subset of the allowed inputs for <code>model</code>.",ne,$,L,ge,W,Te="Validates the export by checking that the outputs from both the reference and the exported model match.",re,Q,ae;return l=new _e({props:{title:"Export functions",local:"export-functions",headingTag:"h1"}}),X=new _e({props:{title:"Main functions",local:"optimum.exporters.onnx.main_export",headingTag:"h2"}}),M=new B({props:{name:"optimum.exporters.onnx.main_export",anchor:"optimum.exporters.onnx.main_export",parameters:[{name:"model_name_or_path",val:": str"},{name:"output",val:": typing.Union[str, pathlib.Path]"},{name:"task",val:": str = 'auto'"},{name:"opset",val:": typing.Optional[int] = None"},{name:"device",val:": str = 'cpu'"},{name:"fp16",val:": typing.Optional[bool] = False"},{name:"optimize",val:": typing.Optional[str] = None"},{name:"monolith",val:": bool = False"},{name:"no_post_process",val:": bool = False"},{name:"framework",val:": typing.Optional[str] = None"},{name:"atol",val:": typing.Optional[float] = None"},{name:"cache_dir",val:": typing.Optional[str] = None"},{name:"trust_remote_code",val:": bool = False"},{name:"pad_token_id",val:": typing.Optional[int] = None"},{name:"subfolder",val:": str = ''"},{name:"revision",val:": str = 'main'"},{name:"force_download",val:": bool = False"},{name:"local_files_only",val:": bool = False"},{name:"use_auth_token",val:": typing.Union[str, bool, NoneType] = None"},{name:"for_ort",val:": bool = False"},{name:"do_validation",val:": bool = True"},{name:"model_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"},{name:"custom_onnx_configs",val:": typing.Union[typing.Dict[str, ForwardRef('OnnxConfig')], NoneType] = None"},{name:"fn_get_submodels",val:": typing.Optional[typing.Callable] = None"},{name:"use_subprocess",val:": bool = False"},{name:"_variant",val:": str = 'default'"},{name:"library_name",val:": typing.Optional[str] = None"},{name:"legacy",val:": bool = False"},{name:"**kwargs_shapes",val:""}],source:"https://github.com/huggingface/optimum/blob/main/optimum/exporters/onnx/__main__.py#L163",parameterGroups:[{title:"Required parameters",parametersDescription:[{anchor:"optimum.exporters.onnx.main_export.model_name_or_path",description:`<strong>model_name_or_path</strong> (<code>str</code>) &#x2014;
Model ID on huggingface.co or path on disk to the model repository to export.`,name:"model_name_or_path"},{anchor:"optimum.exporters.onnx.main_export.output",description:`<strong>output</strong> (<code>Union[str, Path]</code>) &#x2014;
Path indicating the directory where to store the generated ONNX model.`,name:"output"}]},{title:"Optional parameters",parametersDescription:[{anchor:"optimum.exporters.onnx.main_export.task",description:`<strong>task</strong> (<code>Optional[str]</code>, defaults to <code>None</code>) &#x2014;
The task to export the model for. If not specified, the task will be auto-inferred based on the model. For decoder models,
use <code>xxx-with-past</code> to export the model using past key values in the decoder.`,name:"task"},{anchor:"optimum.exporters.onnx.main_export.opset",description:`<strong>opset</strong> (<code>Optional[int]</code>, defaults to <code>None</code>) &#x2014;
If specified, ONNX opset version to export the model with. Otherwise, the default opset for the given model architecture
will be used.`,name:"opset"},{anchor:"optimum.exporters.onnx.main_export.device",description:`<strong>device</strong> (<code>str</code>, defaults to <code>&quot;cpu&quot;</code>) &#x2014;
The device to use to do the export. Defaults to &#x201C;cpu&#x201D;.`,name:"device"},{anchor:"optimum.exporters.onnx.main_export.fp16",description:`<strong>fp16</strong> (<code>Optional[bool]</code>, defaults to <code>&quot;False&quot;</code>) &#x2014;
Use half precision during the export. PyTorch-only, requires <code>device=&quot;cuda&quot;</code>.`,name:"fp16"},{anchor:"optimum.exporters.onnx.main_export.optimize",description:`<strong>optimize</strong> (<code>Optional[str]</code>, defaults to <code>None</code>) &#x2014;
Allows to run ONNX Runtime optimizations directly during the export. Some of these optimizations are specific to
ONNX Runtime, and the resulting ONNX will not be usable with other runtime as OpenVINO or TensorRT.
Available options: <code>&quot;O1&quot;, &quot;O2&quot;, &quot;O3&quot;, &quot;O4&quot;</code>. Reference: <a href="/docs/optimum/main/en/onnxruntime/package_reference/configuration#optimum.onnxruntime.AutoOptimizationConfig">AutoOptimizationConfig</a>`,name:"optimize"},{anchor:"optimum.exporters.onnx.main_export.monolith",description:`<strong>monolith</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Forces to export the model as a single ONNX file.`,name:"monolith"},{anchor:"optimum.exporters.onnx.main_export.no_post_process",description:`<strong>no_post_process</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Allows to disable any post-processing done by default on the exported ONNX models.`,name:"no_post_process"},{anchor:"optimum.exporters.onnx.main_export.framework",description:`<strong>framework</strong> (<code>Optional[str]</code>, defaults to <code>None</code>) &#x2014;
The framework to use for the ONNX export (<code>&quot;pt&quot;</code> or <code>&quot;tf&quot;</code>). If not provided, will attempt to automatically detect
the framework for the checkpoint.`,name:"framework"},{anchor:"optimum.exporters.onnx.main_export.atol",description:`<strong>atol</strong> (<code>Optional[float]</code>, defaults to <code>None</code>) &#x2014;
If specified, the absolute difference tolerance when validating the model. Otherwise, the default atol for the model will be used.`,name:"atol"},{anchor:"optimum.exporters.onnx.main_export.cache_dir",description:`<strong>cache_dir</strong> (<code>Optional[str]</code>, defaults to <code>None</code>) &#x2014;
Path indicating where to store cache. The default Hugging Face cache path will be used by default.`,name:"cache_dir"},{anchor:"optimum.exporters.onnx.main_export.trust_remote_code",description:`<strong>trust_remote_code</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Allows to use custom code for the modeling hosted in the model repository. This option should only be set for repositories
you trust and in which you have read the code, as it will execute on your local machine arbitrary code present in the
model repository.`,name:"trust_remote_code"},{anchor:"optimum.exporters.onnx.main_export.pad_token_id",description:`<strong>pad_token_id</strong> (<code>Optional[int]</code>, defaults to <code>None</code>) &#x2014;
This is needed by some models, for some tasks. If not provided, will attempt to use the tokenizer to guess it.`,name:"pad_token_id"},{anchor:"optimum.exporters.onnx.main_export.subfolder",description:`<strong>subfolder</strong> (<code>str</code>, defaults to <code>&quot;&quot;</code>) &#x2014;
In case the relevant files are located inside a subfolder of the model repo either locally or on huggingface.co, you can
specify the folder name here.`,name:"subfolder"},{anchor:"optimum.exporters.onnx.main_export.revision",description:`<strong>revision</strong> (<code>str</code>, defaults to <code>&quot;main&quot;</code>) &#x2014;
Revision is the specific model version to use. It can be a branch name, a tag name, or a commit id.`,name:"revision"},{anchor:"optimum.exporters.onnx.main_export.force_download",description:`<strong>force_download</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.`,name:"force_download"},{anchor:"optimum.exporters.onnx.main_export.local_files_only",description:`<strong>local_files_only</strong> (<code>Optional[bool]</code>, defaults to <code>False</code>) &#x2014;
Whether or not to only look at local files (i.e., do not try to download the model).`,name:"local_files_only"},{anchor:"optimum.exporters.onnx.main_export.use_auth_token",description:`<strong>use_auth_token</strong> (<code>Optional[str]</code>, defaults to <code>None</code>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If <code>True</code>, will use the token generated
when running <code>transformers-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"use_auth_token"},{anchor:"optimum.exporters.onnx.main_export.model_kwargs",description:`<strong>model_kwargs</strong> (<code>Optional[Dict[str, Any]]</code>, defaults to <code>None</code>) &#x2014;
Experimental usage: keyword arguments to pass to the model during
the export. This argument should be used along the <code>custom_onnx_configs</code> argument
in case, for example, the model inputs/outputs are changed (for example, if
<code>model_kwargs={&quot;output_attentions&quot;: True}</code> is passed).`,name:"model_kwargs"},{anchor:"optimum.exporters.onnx.main_export.custom_onnx_configs",description:`<strong>custom_onnx_configs</strong> (<code>Optional[Dict[str, OnnxConfig]]</code>, defaults to <code>None</code>) &#x2014;
Experimental usage: override the default ONNX config used for the given model. This argument may be useful for advanced users that desire a finer-grained control on the export. An example is available <a href="https://huggingface.co/docs/optimum/main/en/exporters/onnx/usage_guides/export_a_model" rel="nofollow">here</a>.`,name:"custom_onnx_configs"},{anchor:"optimum.exporters.onnx.main_export.fn_get_submodels",description:`<strong>fn_get_submodels</strong> (<code>Optional[Callable]</code>, defaults to <code>None</code>) &#x2014;
Experimental usage: Override the default submodels that are used at the export. This is
especially useful when exporting a custom architecture that needs to split the ONNX (e.g. encoder-decoder). If unspecified with custom models, optimum will try to use the default submodels used for the given task, with no guarantee of success.`,name:"fn_get_submodels"},{anchor:"optimum.exporters.onnx.main_export.use_subprocess",description:`<strong>use_subprocess</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Do the ONNX exported model validation in subprocesses. This is especially useful when
exporting on CUDA device, where ORT does not release memory at inference session
destruction. When set to <code>True</code>, the <code>main_export</code> call should be guarded in
<code>if __name__ == &quot;__main__&quot;:</code> block.`,name:"use_subprocess"},{anchor:"optimum.exporters.onnx.main_export._variant",description:`<strong>_variant</strong> (<code>str</code>, defaults to <code>default</code>) &#x2014;
Specify the variant of the ONNX export to use.`,name:"_variant"},{anchor:"optimum.exporters.onnx.main_export.library_name",description:`<strong>library_name</strong> (<code>Optional[str]</code>, defaults to <code>None</code>) &#x2014;
The library of the model (<code>&quot;tansformers&quot;</code> or <code>&quot;diffusers&quot;</code> or <code>&quot;timm&quot;</code> or <code>&quot;sentence_transformers&quot;</code>). If not provided, will attempt to automatically detect the library name for the checkpoint.`,name:"library_name"},{anchor:"optimum.exporters.onnx.main_export.legacy",description:`<strong>legacy</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Disable the use of position_ids for text-generation models that require it for batched generation. Also enable to export decoder only models in three files (without + with past and the merged model). This argument is introduced for backward compatibility and will be removed in a future release of Optimum.`,name:"legacy"},{anchor:"optimum.exporters.onnx.main_export.*kwargs_shapes",description:`*<strong>*kwargs_shapes</strong> (<code>Dict</code>) &#x2014;
Shapes to use during inference. This argument allows to override the default shapes used during the ONNX export.`,name:"*kwargs_shapes"}]}]}}),q=new Xe({props:{anchor:"optimum.exporters.onnx.main_export.example",$$slots:{default:[Me]},$$scope:{ctx:J}}}),E=new B({props:{name:"optimum.exporters.onnx.export",anchor:"optimum.exporters.onnx.export",parameters:[{name:"model",val:": typing.Union[ForwardRef('PreTrainedModel'), ForwardRef('TFPreTrainedModel'), ForwardRef('ModelMixin')]"},{name:"config",val:": OnnxConfig"},{name:"output",val:": Path"},{name:"opset",val:": typing.Optional[int] = None"},{name:"device",val:": str = 'cpu'"},{name:"input_shapes",val:": typing.Optional[typing.Dict] = None"},{name:"disable_dynamic_axes_fix",val:": typing.Optional[bool] = False"},{name:"dtype",val:": typing.Optional[str] = None"},{name:"model_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"}],parametersDescription:[{anchor:"optimum.exporters.onnx.export.model",description:`<strong>model</strong> (<code>PreTrainedModel</code> or <code>TFPreTrainedModel</code>) &#x2014;
The model to export.`,name:"model"},{anchor:"optimum.exporters.onnx.export.config",description:`<strong>config</strong> (<a href="/docs/optimum/main/en/exporters/onnx/package_reference/configuration#optimum.exporters.onnx.OnnxConfig">OnnxConfig</a>) &#x2014;
The ONNX configuration associated with the exported model.`,name:"config"},{anchor:"optimum.exporters.onnx.export.output",description:`<strong>output</strong> (<code>Path</code>) &#x2014;
Directory to store the exported ONNX model.`,name:"output"},{anchor:"optimum.exporters.onnx.export.opset",description:`<strong>opset</strong> (<code>Optional[int]</code>, defaults to <code>None</code>) &#x2014;
The version of the ONNX operator set to use.`,name:"opset"},{anchor:"optimum.exporters.onnx.export.device",description:`<strong>device</strong> (<code>Optional[str]</code>, defaults to <code>&quot;cpu&quot;</code>) &#x2014;
The device on which the ONNX model will be exported. Either <code>cpu</code> or <code>cuda</code>. Only PyTorch is supported for
export on CUDA devices.`,name:"device"},{anchor:"optimum.exporters.onnx.export.input_shapes",description:`<strong>input_shapes</strong> (<code>Optional[Dict]</code>, defaults to <code>None</code>) &#x2014;
If specified, allows to use specific shapes for the example input provided to the ONNX exporter.`,name:"input_shapes"},{anchor:"optimum.exporters.onnx.export.disable_dynamic_axes_fix",description:`<strong>disable_dynamic_axes_fix</strong> (<code>Optional[bool]</code>, defaults to <code>False</code>) &#x2014;
Whether to disable the default dynamic axes fixing.`,name:"disable_dynamic_axes_fix"},{anchor:"optimum.exporters.onnx.export.dtype",description:`<strong>dtype</strong> (<code>Optional[str]</code>, defaults to <code>None</code>) &#x2014;
Data type to remap the model inputs to. PyTorch-only. Only <code>fp16</code> is supported.`,name:"dtype"},{anchor:"optimum.exporters.onnx.export.model_kwargs",description:`<strong>model_kwargs</strong> (<code>Optional[Dict[str, Any]]</code>, defaults to <code>None</code>) &#x2014;
Experimental usage: keyword arguments to pass to the model during
the export. This argument should be used along the <code>custom_onnx_config</code> argument
in case, for example, the model inputs/outputs are changed (for example, if
<code>model_kwargs={&quot;output_attentions&quot;: True}</code> is passed).`,name:"model_kwargs"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/exporters/onnx/convert.py#L770",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A tuple with an ordered list of the model’s inputs, and the named outputs from
the ONNX configuration.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>Tuple[List[str], List[str]]</code></p>
`}}),I=new B({props:{name:"optimum.exporters.onnx.convert.export_pytorch",anchor:"optimum.exporters.onnx.convert.export_pytorch",parameters:[{name:"model",val:": typing.Union[ForwardRef('PreTrainedModel'), ForwardRef('ModelMixin')]"},{name:"config",val:": OnnxConfig"},{name:"opset",val:": int"},{name:"output",val:": Path"},{name:"device",val:": str = 'cpu'"},{name:"dtype",val:": typing.Optional[ForwardRef('torch.dtype')] = None"},{name:"input_shapes",val:": typing.Optional[typing.Dict] = None"},{name:"model_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"}],parametersDescription:[{anchor:"optimum.exporters.onnx.convert.export_pytorch.model",description:`<strong>model</strong> (<code>PreTrainedModel</code>) &#x2014;
The model to export.`,name:"model"},{anchor:"optimum.exporters.onnx.convert.export_pytorch.config",description:`<strong>config</strong> (<a href="/docs/optimum/main/en/exporters/onnx/package_reference/configuration#optimum.exporters.onnx.OnnxConfig">OnnxConfig</a>) &#x2014;
The ONNX configuration associated with the exported model.`,name:"config"},{anchor:"optimum.exporters.onnx.convert.export_pytorch.opset",description:`<strong>opset</strong> (<code>int</code>) &#x2014;
The version of the ONNX operator set to use.`,name:"opset"},{anchor:"optimum.exporters.onnx.convert.export_pytorch.output",description:`<strong>output</strong> (<code>Path</code>) &#x2014;
Path to save the exported ONNX file to.`,name:"output"},{anchor:"optimum.exporters.onnx.convert.export_pytorch.device",description:`<strong>device</strong> (<code>str</code>, defaults to <code>&quot;cpu&quot;</code>) &#x2014;
The device on which the ONNX model will be exported. Either <code>cpu</code> or <code>cuda</code>. Only PyTorch is supported for
export on CUDA devices.`,name:"device"},{anchor:"optimum.exporters.onnx.convert.export_pytorch.dtype",description:`<strong>dtype</strong> (<code>Optional[torch.dtype]</code>, defaults to <code>None</code>) &#x2014;
Data type to remap the model inputs to. PyTorch-only. Only <code>torch.float16</code> is supported.`,name:"dtype"},{anchor:"optimum.exporters.onnx.convert.export_pytorch.input_shapes",description:`<strong>input_shapes</strong> (<code>Optional[Dict]</code>, defaults to <code>None</code>) &#x2014;
If specified, allows to use specific shapes for the example input provided to the ONNX exporter.`,name:"input_shapes"},{anchor:"optimum.exporters.onnx.convert.export_pytorch.model_kwargs",description:`<strong>model_kwargs</strong> (<code>Optional[Dict[str, Any]]</code>, defaults to <code>None</code>) &#x2014;
Experimental usage: keyword arguments to pass to the model during
the export. This argument should be used along the <code>custom_onnx_config</code> argument
in case, for example, the model inputs/outputs are changed (for example, if
<code>model_kwargs={&quot;output_attentions&quot;: True}</code> is passed).`,name:"model_kwargs"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/exporters/onnx/convert.py#L483",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A tuple with an ordered list of the model’s inputs, and the named outputs from
the ONNX configuration.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>Tuple[List[str], List[str]]</code></p>
`}}),A=new B({props:{name:"optimum.exporters.onnx.convert.export_tensorflow",anchor:"optimum.exporters.onnx.convert.export_tensorflow",parameters:[{name:"model",val:": TFPreTrainedModel"},{name:"config",val:": OnnxConfig"},{name:"opset",val:": int"},{name:"output",val:": Path"}],parametersDescription:[{anchor:"optimum.exporters.onnx.convert.export_tensorflow.model",description:`<strong>model</strong> (<code>TFPreTrainedModel</code>) &#x2014;
The model to export.`,name:"model"},{anchor:"optimum.exporters.onnx.convert.export_tensorflow.config",description:`<strong>config</strong> (<a href="/docs/optimum/main/en/exporters/onnx/package_reference/configuration#optimum.exporters.onnx.OnnxConfig">OnnxConfig</a>) &#x2014;
The ONNX configuration associated with the exported model.`,name:"config"},{anchor:"optimum.exporters.onnx.convert.export_tensorflow.opset",description:`<strong>opset</strong> (<code>int</code>) &#x2014;
The version of the ONNX operator set to use.`,name:"opset"},{anchor:"optimum.exporters.onnx.convert.export_tensorflow.output",description:`<strong>output</strong> (<code>Path</code>) &#x2014;
Directory to store the exported ONNX model.`,name:"output"},{anchor:"optimum.exporters.onnx.convert.export_tensorflow.device",description:`<strong>device</strong> (<code>Optional[str]</code>, defaults to <code>&quot;cpu&quot;</code>) &#x2014;
The device on which the ONNX model will be exported. Either <code>cpu</code> or <code>cuda</code>. Only PyTorch is supported for
export on CUDA devices.`,name:"device"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/exporters/onnx/convert.py#L619",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A tuple with an ordered list of the model’s inputs, and the named outputs from
the ONNX configuration.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>Tuple[List[str], List[str]]</code></p>
`}}),R=new _e({props:{title:"Utility functions",local:"optimum.exporters.onnx.convert.check_dummy_inputs_are_allowed",headingTag:"h2"}}),U=new B({props:{name:"optimum.exporters.onnx.convert.check_dummy_inputs_are_allowed",anchor:"optimum.exporters.onnx.convert.check_dummy_inputs_are_allowed",parameters:[{name:"model",val:": typing.Union[ForwardRef('PreTrainedModel'), ForwardRef('TFPreTrainedModel'), ForwardRef('ModelMixin')]"},{name:"dummy_input_names",val:": typing.Iterable[str]"}],parametersDescription:[{anchor:"optimum.exporters.onnx.convert.check_dummy_inputs_are_allowed.model",description:`<strong>model</strong> (<code>Union[transformers.PreTrainedModel, transformers.TFPreTrainedModel</code>]) &#x2014;
The model instance.`,name:"model"},{anchor:"optimum.exporters.onnx.convert.check_dummy_inputs_are_allowed.model_inputs",description:`<strong>model_inputs</strong> (<code>Iterable[str]</code>) &#x2014;
The model input names.`,name:"model_inputs"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/exporters/onnx/convert.py#L65"}}),L=new B({props:{name:"optimum.exporters.onnx.validate_model_outputs",anchor:"optimum.exporters.onnx.validate_model_outputs",parameters:[{name:"config",val:": OnnxConfig"},{name:"reference_model",val:": typing.Union[ForwardRef('PreTrainedModel'), ForwardRef('TFPreTrainedModel'), ForwardRef('ModelMixin')]"},{name:"onnx_model",val:": Path"},{name:"onnx_named_outputs",val:": typing.List[str]"},{name:"atol",val:": typing.Optional[float] = None"},{name:"input_shapes",val:": typing.Optional[typing.Dict] = None"},{name:"device",val:": str = 'cpu'"},{name:"dtype",val:": typing.Optional[ForwardRef('torch.dtype')] = None"},{name:"use_subprocess",val:": typing.Optional[bool] = True"},{name:"model_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"}],parametersDescription:[{anchor:"optimum.exporters.onnx.validate_model_outputs.config",description:`<strong>config</strong> (<code>~OnnxConfig</code> &#x2014;
The configuration used to export the model.`,name:"config"},{anchor:"optimum.exporters.onnx.validate_model_outputs.reference_model",description:`<strong>reference_model</strong> (<code>~PreTrainedModel</code> or <code>~TFPreTrainedModel</code>) &#x2014;
The model used for the export.`,name:"reference_model"},{anchor:"optimum.exporters.onnx.validate_model_outputs.onnx_model",description:`<strong>onnx_model</strong> (<code>Path</code>) &#x2014;
The path to the exported model.`,name:"onnx_model"},{anchor:"optimum.exporters.onnx.validate_model_outputs.onnx_named_outputs",description:`<strong>onnx_named_outputs</strong> (<code>List[str]</code>) &#x2014;
The names of the outputs to check.`,name:"onnx_named_outputs"},{anchor:"optimum.exporters.onnx.validate_model_outputs.atol",description:`<strong>atol</strong> (<code>Optional[float]</code>, defaults to <code>None</code>) &#x2014;
The absolute tolerance in terms of outputs difference between the reference and the exported model.`,name:"atol"},{anchor:"optimum.exporters.onnx.validate_model_outputs.input_shapes",description:`<strong>input_shapes</strong> (<code>Optional[Dict]</code>, defaults to <code>None</code>) &#x2014;
If specified, allows to use specific shapes to validate the ONNX model on.`,name:"input_shapes"},{anchor:"optimum.exporters.onnx.validate_model_outputs.device",description:`<strong>device</strong> (<code>str</code>, defaults to <code>&quot;cpu&quot;</code>) &#x2014;
The device on which the ONNX model will be validated. Either <code>cpu</code> or <code>cuda</code>. Validation on a CUDA device is supported only for PyTorch.`,name:"device"},{anchor:"optimum.exporters.onnx.validate_model_outputs.use_subprocess",description:`<strong>use_subprocess</strong> (<code>Optional[bool]</code>, defaults to <code>True</code>) &#x2014;
Launch validation of each exported model in a subprocess.`,name:"use_subprocess"},{anchor:"optimum.exporters.onnx.validate_model_outputs.model_kwargs",description:`<strong>model_kwargs</strong> (<code>Optional[Dict[str, Any]]</code>, defaults to <code>None</code>) &#x2014;
Experimental usage: keyword arguments to pass to the model during
the export and validation.`,name:"model_kwargs"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/exporters/onnx/convert.py#L178",raiseDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<ul>
<li><code>ValueError</code> — If the outputs shapes or values do not match between the reference and the exported model.</li>
</ul>
`,raiseType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>ValueError</code></p>
`}}),{c(){i=d("meta"),F=r(),b=d("p"),m=r(),h(l.$$.fragment),s=r(),u=d("p"),u.innerHTML=ve,G=r(),h(X.$$.fragment),Z=r(),x=d("div"),h(M.$$.fragment),me=r(),j=d("p"),j.textContent=ye,le=r(),h(q.$$.fragment),Y=r(),w=d("div"),h(E.$$.fragment),ue=r(),z=d("p"),z.textContent=be,K=r(),N=d("div"),h(I.$$.fragment),xe=r(),V=d("p"),V.textContent=we,ee=r(),O=d("div"),h(A.$$.fragment),he=r(),H=d("p"),H.textContent=Ne,oe=r(),h(R.$$.fragment),te=r(),T=d("div"),h(U.$$.fragment),fe=r(),S=d("p"),S.innerHTML=Oe,ne=r(),$=d("div"),h(L.$$.fragment),ge=r(),W=d("p"),W.textContent=Te,re=r(),Q=d("p"),this.h()},l(e){const t=Ce("svelte-u9bgzb",document.head);i=p(t,"META",{name:!0,content:!0}),t.forEach(o),F=a(e),b=p(e,"P",{}),P(b).forEach(o),m=a(e),f(l.$$.fragment,e),s=a(e),u=p(e,"P",{"data-svelte-h":!0}),C(u)!=="svelte-opxd2k"&&(u.innerHTML=ve),G=a(e),f(X.$$.fragment,e),Z=a(e),x=p(e,"DIV",{class:!0});var k=P(x);f(M.$$.fragment,k),me=a(k),j=p(k,"P",{"data-svelte-h":!0}),C(j)!=="svelte-5kbxab"&&(j.textContent=ye),le=a(k),f(q.$$.fragment,k),k.forEach(o),Y=a(e),w=p(e,"DIV",{class:!0});var se=P(w);f(E.$$.fragment,se),ue=a(se),z=p(se,"P",{"data-svelte-h":!0}),C(z)!=="svelte-1faqzsd"&&(z.textContent=be),se.forEach(o),K=a(e),N=p(e,"DIV",{class:!0});var ie=P(N);f(I.$$.fragment,ie),xe=a(ie),V=p(ie,"P",{"data-svelte-h":!0}),C(V)!=="svelte-h0jnyb"&&(V.textContent=we),ie.forEach(o),ee=a(e),O=p(e,"DIV",{class:!0});var de=P(O);f(A.$$.fragment,de),he=a(de),H=p(de,"P",{"data-svelte-h":!0}),C(H)!=="svelte-1e5bu6f"&&(H.textContent=Ne),de.forEach(o),oe=a(e),f(R.$$.fragment,e),te=a(e),T=p(e,"DIV",{class:!0});var pe=P(T);f(U.$$.fragment,pe),fe=a(pe),S=p(pe,"P",{"data-svelte-h":!0}),C(S)!=="svelte-rrh373"&&(S.innerHTML=Oe),pe.forEach(o),ne=a(e),$=p(e,"DIV",{class:!0});var ce=P($);f(L.$$.fragment,ce),ge=a(ce),W=p(ce,"P",{"data-svelte-h":!0}),C(W)!=="svelte-1w8b0fb"&&(W.textContent=Te),ce.forEach(o),re=a(e),Q=p(e,"P",{}),P(Q).forEach(o),this.h()},h(){D(i,"name","hf:doc:metadata"),D(i,"content",Ie),D(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),D(w,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),D(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),D(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),D(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),D($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,t){c(document.head,i),n(e,F,t),n(e,b,t),n(e,m,t),g(l,e,t),n(e,s,t),n(e,u,t),n(e,G,t),g(X,e,t),n(e,Z,t),n(e,x,t),g(M,x,null),c(x,me),c(x,j),c(x,le),g(q,x,null),n(e,Y,t),n(e,w,t),g(E,w,null),c(w,ue),c(w,z),n(e,K,t),n(e,N,t),g(I,N,null),c(N,xe),c(N,V),n(e,ee,t),n(e,O,t),g(A,O,null),c(O,he),c(O,H),n(e,oe,t),g(R,e,t),n(e,te,t),n(e,T,t),g(U,T,null),c(T,fe),c(T,S),n(e,ne,t),n(e,$,t),g(L,$,null),c($,ge),c($,W),n(e,re,t),n(e,Q,t),ae=!0},p(e,[t]){const k={};t&2&&(k.$$scope={dirty:t,ctx:e}),q.$set(k)},i(e){ae||(_(l.$$.fragment,e),_(X.$$.fragment,e),_(M.$$.fragment,e),_(q.$$.fragment,e),_(E.$$.fragment,e),_(I.$$.fragment,e),_(A.$$.fragment,e),_(R.$$.fragment,e),_(U.$$.fragment,e),_(L.$$.fragment,e),ae=!0)},o(e){v(l.$$.fragment,e),v(X.$$.fragment,e),v(M.$$.fragment,e),v(q.$$.fragment,e),v(E.$$.fragment,e),v(I.$$.fragment,e),v(A.$$.fragment,e),v(R.$$.fragment,e),v(U.$$.fragment,e),v(L.$$.fragment,e),ae=!1},d(e){e&&(o(F),o(b),o(m),o(s),o(u),o(G),o(Z),o(x),o(Y),o(w),o(K),o(N),o(ee),o(O),o(oe),o(te),o(T),o(ne),o($),o(re),o(Q)),o(i),y(l,e),y(X,e),y(M),y(q),y(E),y(I),y(A),y(R,e),y(U),y(L)}}}const Ie='{"title":"Export functions","local":"export-functions","sections":[{"title":"Main functions","local":"optimum.exporters.onnx.main_export","sections":[],"depth":2},{"title":"Utility functions","local":"optimum.exporters.onnx.convert.check_dummy_inputs_are_allowed","sections":[],"depth":2}],"depth":1}';function Ae(J){return ke(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class He extends Pe{constructor(i){super(),De(this,i,Ae,Ee,$e,{})}}export{He as component};
